include:
  - local: .gitlab-ci/jobs/eslint_template.yml
  - local: .gitlab-ci/jobs/pylint_template.yml
  - local: .gitlab-ci/jobs/pytest_template.yml

stages:
  - lint
  - test

variables:
  PYTHON_39_IMAGE: python:3.9
  PYTHON_38_IMAGE: python:3.8
  NODE_15_IMAGE: node:15

pylint:3.8:
  stage: lint
  variables:
    IMAGE_NAME: $PYTHON_38_IMAGE
    LINT_PATH: ./app/python/*.py
    PIP_REQUIREMENTS_PATH: $PIP_REQUIREMENTS_PATH
  extends:
    - .pylint_template

pylint:3.9:
  stage: lint
  variables:
    IMAGE_NAME: $PYTHON_39_IMAGE
    PIP_REQUIREMENTS_PATH: ./app/python/requirements.txt
    LINT_PATH: ./app/python/*.py
  extends:
    - .pylint_template

eslint:
  stage: lint
  variables:
    ESLINT_PATH: ./app/javascript
    PACKAGES_PATH: ./app/javascript
    IMAGE_NAME: $NODE_15_IMAGE
  extends:
    - .eslint_template

pytest:3.8:
  stage: test
  variables:
    IMAGE_NAME: $PYTHON_38_IMAGE
    PIP_REQUIREMENTS_PATH: ./app/python/requirements.txt
    TEST_PATH: ./app/python/test_func.py
  extends:
      - .pytest_template

pytest:3.9:
  stage: test
  variables:
    IMAGE_NAME: $PYTHON_39_IMAGE
    PIP_REQUIREMENTS_PATH: ./app/python/requirements.txt
    TEST_PATH: ./app/python/test_func.py
  extends:
      - .pytest_template
